/*
 * QueenTestHillClimbing.java
 *
 * Created on 21. listopad 2006, 22:35
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package pa161.uloha_4;

import java.util.ArrayList;
import java.util.Iterator;

/**
 *
 * @author xmatena
 */
public class QueenTestHillClimbing {
    
    /**
     * Constructor for objects of class QueenTestHillClimbing
     */
    public QueenTestHillClimbing()  {
    }
    
    public static void main(String args[]) {
        
        boolean DEBUG = false;
        java.util.Random generator = new java.util.Random(19580427);
        
        /*create situation*/
        ArrayList<Queen> game = new ArrayList<Queen>(8);
        
    /*  UHLOPRICKA
         game.add(new Queen('a',8));
        game.add(new Queen('b',7));
        game.add(new Queen('c',6));
        game.add(new Queen('d',5));
        game.add(new Queen('e',4));
        game.add(new Queen('f',3));
        game.add(new Queen('g',2));
        game.add(new Queen('h',1));
     
        DOMACI ULOHA I 
        game.add(new Queen('a',7));
        game.add(new Queen('e',8));
        game.add(new Queen('f',6));
        game.add(new Queen('d',5));
        game.add(new Queen('b',4));
        game.add(new Queen('g',3));
        game.add(new Queen('c',2));
        game.add(new Queen('h',1));
     
        DOMACI ULOHA II - test
     
        game.add(new Queen('a',4));
        game.add(new Queen('e',3));
        game.add(new Queen('f',2));
        game.add(new Queen('d',5));
        game.add(new Queen('b',4));
        game.add(new Queen('g',3));
        game.add(new Queen('c',2));
        game.add(new Queen('h',3));
     
  /*      DOMACI ULOHA II - zadani
     
        game.add(new Queen('a',4));
        game.add(new Queen('b',3));
        game.add(new Queen('c',2));
        game.add(new Queen('d',5));
        game.add(new Queen('e',4));
        game.add(new Queen('f',3));
        game.add(new Queen('g',2));
        game.add(new Queen('h',3));
*/
        game.add(new Queen('a',1));
        game.add(new Queen('e',8));
        game.add(new Queen('f',6));
        game.add(new Queen('d',4));
        game.add(new Queen('b',4));
        game.add(new Queen('g',3));
        game.add(new Queen('c',2));
        game.add(new Queen('h',7));
 
        System.out.println("\n------------------");
        for (Iterator k = game.iterator(); k.hasNext(); ) {
            System.out.print((Queen) k.next());
        }
        System.out.println();
        
        
        System.out.println("Pocet kolizi: " + performThreatenTest(game));
        
        ArrayList<Queen> bestGame = new ArrayList<Queen>(8);
        int currentScore = Integer.MAX_VALUE; //current best score
        int qScore = Integer.MAX_VALUE; //score from this round
        int boardScore;
        Queen q;
        
        int moveCounter=0;
        
        int x;
        int y;
        
        ArrayList<ArrayList<Queen>> equalGames = new ArrayList<ArrayList<Queen>>();
        
        
        currentScore = performThreatenTest(game);
        while (currentScore != 0) {
            
            for (x = 1; x<9 ; x++) { //procházíme všech osm dam
                for (int vInc = 1; vInc<8; vInc++ ) { //posouvame o 1 az 7 poli (na kraji jdeme znovu odspodu
                    ArrayList<Queen> currentGame = new ArrayList<Queen>(8);
                    currentGame = (ArrayList<Queen>) game.clone();
                    Queen moved = currentGame.get(x-1);
                    y = ((moved.getY() + vInc) % 8)+1;
                    currentGame.set(x-1,new Queen(moved.getX(),y));
                    if (DEBUG) System.out.println(moved.toString() + (new Queen(moved.getX(),y)).toString() );
                    
                    boardScore = performThreatenTest(currentGame);
                    
                    if (boardScore <= qScore) {
                        if (boardScore < qScore) { //nejsme na plosine
                            equalGames.clear();
                            qScore = boardScore;
                        }
                        
                        equalGames.add(currentGame);
                        
                        bestGame = currentGame;
                        
                    }
                    
                }
            }
            
            
            if (qScore > currentScore) {
                System.out.println("Dosahli jsme lokalního extrému evaluační funkce");
                break;
            }
            currentScore = qScore;
            qScore = Integer.MAX_VALUE;
            moveCounter++;
            
            game.clear(); //smazeme starou hru
            
            //do the best move
            if (equalGames.size() > 1) { //we are on a plain
                game.addAll(equalGames.get(generator.nextInt(equalGames.size())));
            } else {
                game.addAll(bestGame);
            }
            
            for (Iterator k = game.iterator(); k.hasNext(); ) {
                System.out.print((Queen) k.next());
            }
            System.out.println();
            
            equalGames.clear();
        } //main while <> 0 loop
        System.out.println("Celkem kroku "+moveCounter);
        System.out.println("Vysledny pocet kolizi "+currentScore);
        
    }
    
    /**
     * Zjistí zda na poli (x,y) nestojí dáma, která není uvedena ve vyjímce
     * pokud stojí vrátí false
     * jinak vrátí true (tedy pokud na daném poli stojí dáma except)
     */
    public static boolean isLegalMove(int x, int y, Queen except, ArrayList<Queen> game) {
        boolean result = true;
        Queen t;
        for(Iterator jt = game.iterator(); jt.hasNext(); ) {
            
            t = (Queen) jt.next();
            if (!except.equals(t)) {
                if ((x == t.getX()) && (y == t.getY())) {
                    result = false;
                    return false;
                }
            }
        }
        return result;
    }
    
    
    /**
     * Najde počet ohrožených dam v dané hře
     */
    public static int performThreatenTest(ArrayList<Queen> game) {
        int result = 0;
        int now;
        boolean DEBUG = false;
        
        for(Iterator jt = game.iterator(); jt.hasNext(); ) {
            Queen t;
            t = (Queen) jt.next();
            now = performThreatenTest(t.getX(),t.getY(),game);
            result += now;
            if (DEBUG) {
                System.out.println("["+ (char) t.getX()+","+t.getY()+"] vidi " + now + "dam");
            }
        }
        if (DEBUG) System.out.println("---");
        return result;
    }
    
    /**
     * Najde počet ohrožených dam z dané pozice
     */
    public static int performThreatenTest(int x, int y, ArrayList<Queen> game) {
        boolean DEBUG = false;
        int threatenCount = 0;
        boolean exitDirection;
        int hash;
        
        // left
        exitDirection = false;
        for (int xa = x+1; xa<'i' ;xa++) {
            hash = Queen.getHashCode(xa,y);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        // right
        exitDirection = false;
        for (int xa = x-1; xa>= 'a' ;xa--) { // 93 == 'a' - 1
            hash = Queen.getHashCode(xa,y);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        // up
        exitDirection = false;
        for (int ya = y+1; ya < 9 ;ya++) {
            hash = Queen.getHashCode(x,ya);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        // down
        exitDirection = false;
        for (int ya = y-1; ya > 0 ;ya--) {
            hash = Queen.getHashCode(x,ya);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        
        // right up
        exitDirection = false;
        int umax = (('h'-x) < (8-y)) ? ('h'-x) : (8-y);
        if (DEBUG) System.out.print("ru:"+umax + " ");
        
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x+u,y+u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        // left up
        exitDirection = false;
        umax = ((x-'a') < (8-y)) ? (x-'a') : (8-y);
        if (DEBUG) System.out.print("lu:"+umax + " ");
        
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x-u,y+u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        // left down
        exitDirection = false;
        umax = ((x-'a') < (y-1)) ? (x-'a') : (y-1);
        if (DEBUG) System.out.print("ld:"+umax + " ");
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x-u,y-u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        // right down
        exitDirection = false;
        umax = (('h'-x) < (y-1)) ? ('h'-x) : (y-1);
        if (DEBUG) System.out.print("rd:"+umax + " ");
        for (int u = 1; u <= umax ; u++) {
            hash = Queen.getHashCode(x+u,y-u);
            
            for(Iterator jt = game.iterator(); jt.hasNext(); ) {
                Queen t;
                t = (Queen) jt.next();
                if (t.hashCode() == hash) {
                    threatenCount++;
                    exitDirection = true;
                    break;
                }
            }
            if (exitDirection) {
                break;
            }
        }
        
        if (DEBUG) System.out.println();
        return threatenCount;
    }
    
    public static ArrayList<Queen> cloneExcept(Queen except, ArrayList<Queen> game) {
        ArrayList<Queen> result = new ArrayList<Queen>();
        Queen actual;
        for(Iterator i = game.iterator(); i.hasNext(); ) {
            actual = (Queen) i.next();
            if (!actual.equals(except)) {
                result.add(actual);
            }
        }
        return result;
    }
    
}



